/*
	(C) 1995-96 AROS - The Amiga Research OS
	$Id: releasegirport.c,v 1.1.1.1 2005/03/15 15:54:21 laire Exp $
 
	Desc: Intuition function ReleaseGIRPort()
	Lang: english
*/
#include <proto/graphics.h>
#include <proto/layers.h>
#include "intuition_intern.h"

#define XRP(x) ((struct ExtRastPort *)(x))

/*****************************************************************************
 
	NAME */
#include <graphics/rastport.h>
#include <proto/intuition.h>

AROS_LH1(void, ReleaseGIRPort,

		 /*  SYNOPSIS */
		 AROS_LHA(struct RastPort *, rp, A0),

		 /*  LOCATION */
		 struct IntuitionBase *, IntuitionBase, 94, Intuition)

/*  FUNCTION
	Release a RastPort previously obtained by ObtainGIRPort().
 
	INPUTS
	rp - The result of ObtainGIRPort()
 
	RESULT
	None.
 
	NOTES
 
	EXAMPLE
 
	BUGS
 
	SEE ALSO
 
	INTERNALS
 
	HISTORY
	29-10-95    digulla automatically created from
			    intuition_lib.fd and clib/intuition_protos.h
 
*****************************************************************************/
{
	AROS_LIBFUNC_INIT
	AROS_LIBBASE_EXT_DECL(struct IntuitionBase *,IntuitionBase)

	DEBUG_RELEASEGIRPORT(dprintf("ReleaseGIRPort: RPort 0x%lx\n", rp));

	if (rp)
	{
		if (XRP(rp)->rport.Layer)
		{
			InstallClipRegion(XRP(rp)->rport.Layer,XRP(rp)->context.clipregion);

			XRP(rp)->rport.Layer->Scroll_X = XRP(rp)->context.scroll_x;
			XRP(rp)->rport.Layer->Scroll_Y = XRP(rp)->context.scroll_y;

			/*	bug("----------- RELEASE: %x\n",rp->Layer);*/
			UnlockLayer(XRP(rp)->rport.Layer);
		}

		UNLOCKGADGET

		if (XRP(rp)->rport.Layer) UnlockLayerInfo(XRP(rp)->rport.Layer->LayerInfo);

		FreeRastPortContext (IntuitionBase, XRP(rp));
	}

	AROS_LIBFUNC_EXIT
} /* ReleaseGIRPort */
